/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalfoWizard = {
context: null,current: null,data: null,res: null,seq: null,folder: null,status: null,wizard: null,init: function () {
this.wizard = document.documentElement
this.data = opener.CalFolder.data
this.res = window.arguments[0].QueryInterface(Components.interfaces.nsIRDFResource)
this.seq = this.data.seq(this.res)
this.folder = opener.CalFolder.folders[this.res.Value]
this.wizard._wizardHeader.setAttribute("typelabel", this.wizard.getAttribute("typelabel"))
document.getElementById("intro-name").value = this.data.getName(this.res)
document.getElementById("intro-calendars").value = this.seq.GetCount()
document.getElementById("intro-filters").value = this.folder.filter.length
this.status = document.getElementById("status")
this.backButton = this.wizard.getButton("back")
this.nextButton = this.wizard.getButton("next")
this.finishButton = this.wizard.getButton("finish")
this.cancelButton = this.wizard.getButton("cancel")
this.nextButton.focus()
var h = document.createElement("button")
with (h) {
className = "wizard-button"
setAttribute("dlgtype", "help")
setAttribute("disabled", !opener.openHelp)
setAttribute("label", this.wizard.getAttribute("helpLabel"))
var a = document.createAttribute("oncommand")
a.value = "CalfoWizard.help()"
setAttributeNode(a)}
with (this.cancelButton.parentNode) {
if ((/win|mac/i).test(navigator.platform)) appendChild(h);
else insertBefore(h, firstChild);}
this.cancelButton.parentNode.appendChild(document.createElement("resizer")).setAttribute("dir", "bottomright")
CalfoAction.init()
addEventListener(
"command",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"change",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"select",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"resize",function (event) {CalfoWizard.resize(event)},true)
addEventListener(
"keypress",function (event) {CalfoWizard.keypress(event)},true)
var ww = this.wizard.getElementsByTagName("wizardpage")
for (var i = 0; i < ww.length; ++i) {
ww[i].setAttribute("onpageshow", "return CalfoWizard.page(true)")
ww[i].setAttribute("onpagehide", "return CalfoWizard.page(false)")}
sizeToContent()},compute: function () {
if (!this.wizard) return
var ok = true
switch (this.wizard.currentPage.pageid) {
case "choice":
var a = document.getElementById("choice-list").getElementsByAttribute("checked", "true")
var page = this.wizard.currentPage
var t = ""
for (var i = 0; i < a.length; ++i) {
var id = a[i].value
page.next = id
page = this.wizard.getPageById(id)
t += (t == ""? "" : ", ") + a[i].label}
var c = document.getElementById("custom-check")
if (c.checked) {
page.next = "custom"
page = this.wizard.getPageById("custom")
t += (t == ""? "" : ", ") + c.getAttribute("labelbase")}
page.next = "final"
var d = document.getElementById("delete-check")
if (d.checked) t = d.getAttribute("labelbase")
document.getElementById("final-actions").value = t
ok = Boolean(a[0]) || c.checked || d.checked
break
case "calendar":

ok = document.getElementById("calendar-menulist").selectedIndex >= 0
break
case "title":
ok = /\S/.test(document.getElementById("title-add-text").value)
&& (document.getElementById("title-radio").value != "change"
|| /\S/.test(document.getElementById("title-find-text").value))
break
case "location":
ok = /\S/.test(document.getElementById("location-menulist").value)
|| document.getElementById("location-clear").checked
break
case "category":
ok = /\S/.test(document.getElementById("category-menulist").value)
|| document.getElementById("category-clear").checked
break
case "description":
ok = /\S/.test(document.getElementById("description-add-text").value)
&& (document.getElementById("description-radio").value != "change"
|| /\S/.test(document.getElementById("description-find-text").value))
break
case "privacy":
ok = Boolean(document.getElementById("privacy-radio").value)
break
case "priority":
ok = Boolean(document.getElementById("priority-radio").value)
break
case "date":
ok = (document.getElementById("date-start").checked
|| document.getElementById("date-due").checked
|| document.getElementById("date-end").checked)
&& /[1-9]/.test(document.getElementById("date-amount-text").value)
break
case "time":
ok = (document.getElementById("time-start").checked
|| document.getElementById("time-due").checked
|| document.getElementById("time-end").checked)
&& (/[1-9]/.test(document.getElementById("time-hour-text").value)
|| /[1-9]/.test(document.getElementById("time-minute-text").value))
break
case "status":
ok = Boolean(document.getElementById("status-radio").value)
break
case "url":
ok = /\S/.test(document.getElementById("url-text").value)
|| document.getElementById("url-clear").checked
break}
this.wizard.canAdvance = ok
var f = document.commandDispatcher.focusedElement
if (f && f.hasAttribute("readonly")) {
if (!this.nextButton.hidden && !this.nextButton.disabled) this.nextButton.focus()
else if (!this.finishButton.hidden && !this.finishButton.disabled) this.finishButton.focus()
else this.cancelButton.focus()}},finish: function () {
dump(">> FINISH \n")
this.wizard.canRewind = false},help: function () {
if (opener.openHelp) opener.openHelp(null, null, document)},_bad: {},inhibit: function (msg, elem) {
this._bad[elem.id] = {msg: msg, elem: elem}
var ok = !Boolean(msg)
if (ok) {
for (var id in this._bad) {
var b = this._bad[id]
if (b.msg) {
msg = b.msg
elem = b.elem
ok = false
break}}}
this.status.value = msg || "THIS IS JUST A DESIGN PROTOTYPE - IT DOES NOT WORK YET"
this.nextButton.disabled = !ok
if (ok) this.nextButton.setAttribute("default", "true")
else {
this.nextButton.removeAttribute("default")
this.cancelButton.focus()}},_input: null,input: function (event) {
if (this._input) clearTimeout(this._input)
var e = {target: event.target, type: "input"}
this._input = setTimeout(function () {
CalfoWizard._input = null
CalfoWizard.logic(e)},600)},keypress: function (event) {
if (event.target.className == "amount-text") {
var c = event.charCode
var v = event.target.value
if (c && (c < 48 || c > 57) && !event.ctrlKey && !event.altKey) event.preventDefault()
if (/\D/.test(v)) event.target.value = v.replace(/\D/g, "")}
if (event.keyCode == event.DOM_VK_ENTER || event.keyCode == event.DOM_VK_RETURN) {
event.stopPropagation()}},listSelect: function (event) {
var list = event.target
if (list.localName == "listitem") list = list.parentNode
if (event.type == "keypress" && list.localName != "listbox") return
if (event.type == "click" || event.charCode == 32) {
var c = list.selectedItem
if (!c) return
if (c.firstChild) {
c = c.firstChild
if (c.hasAttribute("checked")) c.removeAttribute("checked")
else c.setAttribute("checked", "true")}}
else if (event.charCode == 97) {
var n = list.getRowCount()
for (var i = 0; i < n; ++i) {
var c = list.getItemAtIndex(i)
if (c.firstChild) c = c.firstChild
c.setAttribute("checked", "true")}}
this.logic({target:list})},logic: function (event) {
var elem = event.target
if (elem.localName == "radio") return
if (elem.localName == "textbox" && event.type == "select") return
var chk = elem.checked
switch (elem.id || elem.parentNode.id) {
case "calfolder-change":
return
case "choice-list":
case "custom-check":
break
case "delete-check":
var c = elem.checked
document.getElementById("choice-list-label").disabled = c
var l = document.getElementById("choice-list")
l.disabled = elem.checked
var i = l.firstChild
while (i) {
i.disabled = c
if (c && i.checked) {
i.setAttribute("was", "checked")
i.checked = false}
else if (i.hasAttribute("was")) {
i.removeAttribute("was")
i.checked = true}
i = i.nextSibling}
var i = document.getElementById("custom-check")
i.disabled = c
if (c && i.checked) {
i.setAttribute("was", "checked")
i.checked = false}
else if (i.hasAttribute("was")) {
i.removeAttribute("was")
i.checked = true}
document.getElementById("choice-page").next = c? "final" : "action"
break
case "calendar-menu-popup":
case "calendar-radio":
break
case "title-add-text":
case "title-find-text":
break
case "title-radio":
var d = (elem.value != "change")
for each (var i in ["find-prompt", "find-text", "first-check", "case-check", "regex-check"]) {
var e = document.getElementById("title-" + i)
if (d && !e.disabled) {
if (e.localName == "checkbox") e.setAttribute("was", e.checked), e.checked = false
else if (e.localName == "textbox") e.setAttribute("was", e.value), e.value = ""
e.disabled = true}
else if (!d && e.disabled) {
e.disabled = false
var v = e.getAttribute("was")
e.removeAttribute("was")
if (e.localName == "checkbox") e.checked = (v == "true")
else if (e.localName == "textbox") e.value = v}}
break
case "location-menu-popup":
case "location-menulist":
break
case "location-clear":
var t = document.getElementById("location-menulist")
var l = document.getElementById("location-label")
if (elem.checked) {
t.setAttribute("was", t.value)
t.value = ""
t.disabled = true
l.disabled = true}
else {
t.disabled = false
l.disabled = false
if (t.hasAttribute("was")) t.value = t.getAttribute("was")
t.removeAttribute("was")}
break
case "category-menu-popup":
case "category-menulist":
break
case "category-clear":
var t = document.getElementById("category-menulist")
var l = document.getElementById("category-label")
if (elem.checked) {
t.setAttribute("was", t.value)
t.value = ""
t.disabled = true
l.disabled = true}
else {
t.disabled = false
l.disabled = false
if (t.hasAttribute("was")) t.value = t.getAttribute("was")
t.removeAttribute("was")}
break
case "description-add-text":
case "description-find-text":
break
case "description-radio":
var d = (elem.value != "change")
for each (var i in ["find-prompt", "find-text", "first-check", "case-check", "regex-check"]) {
var e = document.getElementById("description-" + i)
if (d && !e.disabled) {
if (e.localName == "checkbox") e.setAttribute("was", e.checked), e.checked = false
else if (e.localName == "textbox") e.setAttribute("was", e.value), e.value = ""
e.disabled = true}
else if (!d && e.disabled) {
e.disabled = false
var v = e.getAttribute("was")
e.removeAttribute("was")
if (e.localName == "checkbox") e.checked = (v == "true")
else if (e.localName == "textbox") e.value = v}}
break
case "privacy-radio":
case "priority-radio":
case "status-radio":
break
case "date-amount-text":
if (event.type == "change") {
var v = elem.value, n = v
if (v) n = parseInt(v).toString()
if (n != v) elem.value = n}
break
case "date-start":
case "date-due":
case "date-end":
case "date-amount-radio":
case "date-direction-radio":
break
case "time-hour-text":
case "time-minute-text":
if (event.type == "change") {
var v = elem.value, n = v
if (v) n = parseInt(v).toString()
if (n != v) elem.value = n}
var h = document.getElementById("time-hour-text")
var m = document.getElementById("time-minute-text")
var t = parseInt(m.value || "0") + 60 * parseInt(h.value || "0")
m.value = t % 60
h.value = Math.floor(t / 60)
break
case "time-start":
case "time-due":
case "time-end":
case "time-direction-radio":
break
case "url-text":
break
case "url-clear":
var t = document.getElementById("url-text")
var l = document.getElementById("url-label")
if (elem.checked) {
t.setAttribute("was", t.value)
t.value = ""
t.disabled = true
l.disabled = true}
else {
t.disabled = false
l.disabled = false
if (t.hasAttribute("was")) t.value = t.getAttribute("was")
t.removeAttribute("was")}
break
default:
dump("logic leak: " + event.type + " from " + elem.localName + " " + elem.id + "\n")
return}
setTimeout(function () {CalfoWizard.compute()}, 0)},page: function (load) {
const tt = ["label", "radio", "checkbox", "button"]
var p = this.wizard.currentPage
for each (var t in tt) {
var ee = p.getElementsByTagName(t)
for (var i = 0; i < ee.length; ++i) {
var e = ee[i], l = null, k = e.getAttribute("accky"), v = ""
if (k) {
switch (t) {
case "label":
l = e
v = e.value
break
case "radio":
case "checkbox":
l = document.getAnonymousElementByAttribute(e, "class", t + "-label")
v = e.getAttribute("label")
break
case "button":
l = null
v = e.getAttribute("label")
break}
if (load) {
e.setAttribute("accesskey", k)
if (l) l.setAttribute("accesskey", k), l.value = v}
else {
e.removeAttribute("accesskey")
if (l) l.removeAttribute("accesskey")}}}}
return true},_width: 0,_height: 0,resize: function (event) {
if (!this._width)
this._width = outerWidth, this._height = outerHeight
else if (outerWidth != this._width || outerHeight != this._height)
resizeTo(Math.max(outerWidth, this._width), Math.max(outerHeight, this._height))},step: function (d) {
setTimeout(function () {CalfoWizard.compute()}, 0)
return true},validate: function (id, val) {
switch (id) {
default:
return val}}}
CalfoAction = {
CM: Components.classes["@mozilla.org/calendar/manager;1"].getService(Components.interfaces.calICalendarManager),prefcat: {},cat: {},loc: {},init: function () {
var p = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("calendar.categories.").getCharPref("names").split(",")
for (var i = 0; i < p.length; ++i) {
var cat = p[i].replace(/^\s*|\s*$/g, "")
if (cat) this.cat[cat.toUpperCase()] = cat}
var a = CalfoWizard.data.getCriteria(CalfoWizard.res)
this.load.init()
this.load.display(this.prefcat, this.loc)},load: {
count: NaN,init: function () {
setCursor("wait")
setTimeout(function () {CalfoAction.load.work()}, 50)},display: function (cat, loc) {
var cl = document.getElementById("category-menu-popup")
var ca = []
for (var c in cat) ca.push(c)
ca.sort()
for each (var c in ca)
with (cl.appendChild(document.createElement("menuitem")))
label = cat[c]
var ll = document.getElementById("location-menu-popup")
var la = []
for (var l in loc) la.push(l)
la.sort()
for each (var l in la)
with (ll.appendChild(document.createElement("menuitem")))
label = loc[l]
var n = CalfoWizard.folder.entries
document.getElementById("intro-entries").value = n
var t = document.getElementById("intro-tell")
if (n == 0) t.value = t.getAttribute("tellno")
else if (n == 1) t.value = t.getAttribute("tellone")
else t.value = t.getAttribute("tellok").replace("%", n)
CalfoWizard.inhibit((n == 0 ? " " : null), t)},work: function () {
var pop = document.getElementById("calendar-menu-popup")
var data = CalfoWizard.data
var ena = data.seq(data.all).GetElements()
var a = []
while (ena.hasMoreElements()) {
var r = ena.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
a.push({name: data.getName(r), uri: data.getURI(r)})}
a.sort(function (a, b) {
a = a.name.toLowerCase(), b = b.name.toLowerCase()
return a == b ? 0 : a < b? -1 : 1})
for each (var c in a)
with (pop.appendChild(document.createElement("menuitem")))
label = c.name, value = c.uri
if (!pop.firstChild) CalfoWizard.inhibit("001", pop)
pop.parentNode.selectedIndex = -1
var lis = CalfoWizard.seq.GetElements()
CalfoWizard.folder.prepare(null)
CalfoAction._listener.init()
var has = false
while (lis.hasMoreElements()) {
var res = lis.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
CalfoWizard.data.cal(res).getItems(0xffff, 0, null, null, CalfoAction._listener)
has = true}
if (!has) CalfoAction._listener.onOperationComplete()},finish: function () {
setCursor("default")}},_listener: {
cat: null,loc: null,init: function () {
this.cat = {}, this.loc = {}
for (var c in CalfoAction.cat) this.cat[c] = CalfoAction.cat[c]
for (var c in CalfoAction.loc) this.loc[c] = CalfoAction.loc[c]},onOperationComplete: function () {
CalfoAction.load.display(this.cat, this.loc)
CalfoAction.load.finish()},onGetResult: function (cal, status, type, detail, count, data) {
for (var i = 0; i < count; ++i) {
var cat = data[i].getProperty("CATEGORIES")
if (cat) {
cat = cat.replace(/^\s*|\s*$/g, "")
if (cat) this.cat[cat.toUpperCase()] = cat}
var loc = data[i].getProperty("LOCATION")
if (loc) {
loc = loc.replace(/^\s*|\s*$/g, "")
if (loc) this.loc[loc.toUpperCase()] = loc}}
CalfoWizard.folder.onGetResult(cal, status, type, detail, count, data)}}}
