/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalfoWizard = {
appInfo: "",context: null,current: null,data: null,res: null,seq: null,folder: null,status: null,wizard: null,closing: false,init: function () {
this.wizard = document.documentElement
this.data = opener.CalFolder.data
this.res = window.arguments[0].QueryInterface(Components.interfaces.nsIRDFResource)
this.seq = this.data.seq(this.res)
this.folder = opener.CalFolder.folders[this.res.Value]
this.wizard._wizardHeader.setAttribute("typelabel", this.wizard.getAttribute("typelabel"))
document.getElementById("intro-name").value = this.data.getName(this.res)
document.getElementById("intro-calendars").value = this.seq.GetCount()
document.getElementById("intro-filters").value = this.folder.filter.length
this.status = document.getElementById("status")
this.backButton = this.wizard.getButton("back")
this.nextButton = this.wizard.getButton("next")
this.finishButton = this.wizard.getButton("finish")
this.cancelButton = this.wizard.getButton("cancel")
this.nextButton.focus()
this.headLabel = document.getElementById("head-label")
this.subheadLabel = document.getElementById("subhead-label")
this.headRadio = document.getElementById("head-radio")
this.subheadRadio = document.getElementById("subhead-radio")
this.sortRadio = document.getElementById("sort-radio")
this.detailList = document.getElementById("detail-list")
this.formatGroup = document.getElementById("file-format-group")
this.formatRadio = document.getElementById("format-radio")
this.pathText = document.getElementById("path-text")
this.titleText = document.getElementById("title-text")
this.styleLabel = document.getElementById("style-label")
this.styleBlank = document.getElementById("style-blank")
this.styleTime = document.getElementById("style-time")
this.styleZone = document.getElementById("style-zone")
this.viewCheck = document.getElementById("view-check")
this.printCheck = document.getElementById("print-check")
this.saveCheck = document.getElementById("save-check")
this.titleText.value = this.titleText.getAttribute("baseValue").replace(/%/, this.folder.name)
var h = document.createElement("button")
with (h) {
className = "wizard-button"
setAttribute("dlgtype", "help")
setAttribute("disabled", !opener.openHelp)
setAttribute("label", this.wizard.getAttribute("helpLabel"))
var a = document.createAttribute("oncommand")
a.value = "CalfoWizard.help()"
setAttributeNode(a)}
with (this.cancelButton.parentNode) {
if ((/win|mac/i).test(navigator.platform)) appendChild(h);
else insertBefore(h, firstChild);}
this.cancelButton.parentNode.appendChild(document.createElement("resizer")).setAttribute("dir", "bottomright")
var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo)
this.appInfo = app.name + " " + app.version + ", Calendar Folders " + opener.CalFolder.version
this.preview.init()
CalfoAction.init()
addEventListener(
"command",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"change",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"select",function (event) {CalfoWizard.logic(event)},true)
addEventListener(
"resize",function (event) {CalfoWizard.resize(event)},true)
addEventListener(
"keypress",function (event) {CalfoWizard.keypress(event)},true)
var ww = this.wizard.getElementsByTagName("wizardpage")
for (var i = 0; i < ww.length; ++i) {
ww[i].setAttribute("onpageshow", "return CalfoWizard.page(true)")
ww[i].setAttribute("onpagehide", "return CalfoWizard.page(false)")}
sizeToContent()},_control: null,// refresh buttons, etc
compute: function () {
if (!this.wizard) return
var ok = true
switch (this.wizard.currentPage.pageid) {
case "spec":
var i0 = this.headRadio.selectedIndex
var i1 = this.subheadRadio.selectedIndex
var i2 = this.sortRadio.selectedIndex
if (i0 == i2 && i0 != i1) {
if (this._control == "head-radio") i1 = i0, this.subheadRadio.selectedIndex = i0
else i0 = i1, this.headRadio.selectedIndex = i1}
this._control = null
var i = this.detailList.firstChild
while (i) {
if (i.disabled) i.disabled = false, i.checked = false
i = i.nextSibling}
with (this.detailList.getItemAtIndex(i0)) checked = false, disabled = true
with (this.detailList.getItemAtIndex(i1)) checked = false, disabled = true
with (this.detailList.getItemAtIndex(i2)) checked = true, disabled = true
this.headLabel.disabled = (i2 == i0)
this.subheadLabel.disabled = (i1 == i0 || i1 == i2)
break
case "preview":
var i0 = this.headRadio.selectedIndex
var i1 = this.subheadRadio.selectedIndex
var i2 = this.sortRadio.selectedIndex
var a = [], i = this.detailList.firstChild
while (i) {
if (i.checked && !i.disabled) a.push(i.value)
i = i.nextSibling}
CalfoAction.refresh({
key0: (i0 == i2)? null : this.detailList.getItemAtIndex(i0).value,key1: (i1 == i2)? null : this.detailList.getItemAtIndex(i1).value,key2: this.detailList.getItemAtIndex(i2).value,detail: a,showLabel: this.styleLabel.checked,showBlank: this.styleBlank.checked,showTime: this.styleTime.checked,showZone: this.styleZone.checked})
break
case "final":
if (this.closing) return
ok = this.viewCheck.checked
|| this.printCheck.checked
|| (this.saveCheck.checked
&& this.formatRadio.selectedIndex >= 0
&& /\S/.test(this.pathText.value))
this.finishButton.disabled = !ok
break}
this.wizard.canAdvance = ok
var f = document.commandDispatcher.focusedElement
if (f && f.hasAttribute("readonly")) {
if (!this.nextButton.hidden && !this.nextButton.disabled) this.nextButton.focus()
else if (!this.finishButton.hidden && !this.finishButton.disabled) this.finishButton.focus()
else this.cancelButton.focus()}},finish: function () {
this.closing = true
this.finishButton.disabled = true
this.backButton.disabled = true
if (this.viewCheck.checked) this.preview.view()
if (this.printCheck.checked) this.preview.print()
if (this.saveCheck.checked) this.preview.save(this.formatRadio.value, this.pathText.value)
setTimeout(function () {close()}, 600)},help: function () {
if (opener.openHelp) opener.openHelp(null, null, document)},_bad: {},inhibit: function (msg, elem) {
this._bad[elem.id] = {msg: msg, elem: elem}
var ok = !Boolean(msg)
if (ok) {
for (var id in this._bad) {
var b = this._bad[id]
if (b.msg) {
msg = b.msg
elem = b.elem
ok = false
break}}}
this.status.value = msg || " "
this.nextButton.disabled = !ok
if (ok) this.nextButton.setAttribute("default", "true")
else {
this.nextButton.removeAttribute("default")
this.cancelButton.focus()}},_input: null,input: function (event) {
if (this._input) clearTimeout(this._input)
var e = {target: event.target, type: "input"}
this._input = setTimeout(function () {
CalfoWizard._input = null
CalfoWizard.logic(e)},600)},keypress: function (event) {
if (event.target.className == "amount-text") {
var c = event.charCode
var v = event.target.value
if (c && (c < 48 || c > 57) && !event.ctrlKey && !event.altKey) event.preventDefault()
if (/\D/.test(v)) event.target.value = v.replace(/\D/g, "")}
if (event.keyCode == event.DOM_VK_ENTER || event.keyCode == event.DOM_VK_RETURN) {
event.stopPropagation()}},listSelect: function (event) {
var list = event.target
if (list.localName == "listitem") list = list.parentNode
if (event.type == "keypress" && list.localName != "listbox") return
if (event.type == "click" || event.charCode == 32) {
var c = list.selectedItem
if (!c) return
if (c.firstChild) {
c = c.firstChild
if (c.hasAttribute("checked")) c.removeAttribute("checked")
else c.setAttribute("checked", "true")}}
else if (event.charCode == 97) {
var n = list.getRowCount()
for (var i = 0; i < n; ++i) {
var c = list.getItemAtIndex(i)
if (c.firstChild) c = c.firstChild
c.setAttribute("checked", "true")}}
this.logic({target:list})},logic: function (event) {
var elem = event.target
if (elem.localName == "radio") return
if (elem.localName == "wizard") return
if (elem.localName == "textbox" && event.type == "select") return
var chk = elem.checked
switch (elem.id || elem.parentNode.id) {
case "head-radio":
this._control = elem.id
break
case "subhead-radio":
this._control = elem.id
break
case "sort-radio":
break
case "detail-list":
break
case "style-label":
this.styleBlank.disabled = !elem.checked
break
case "style-blank":
break
case "style-zone":
break
case "style-time":
this.styleZone.disabled = !elem.checked
break
case "view-check":
case "print-check":
break
case "save-check":
var c = elem.checked
this.formatGroup.disabled = !c
break
case "format-radio":
case "path-text":
break
case "browse-button":
var f = this.formatRadio.value
var p = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker)
if (f) p.appendFilters(f == "text"? p.filterText : f == "html"? p.filterHTML : f == "xml"? p.filterXML : 0)
p.appendFilters(p.filterAll)
if (!f) p.appendFilters(p.filterText + p.filterHTML + p.filterXML)
var ext = (f == "text"? "txt" : f == "html"? "html" : f == "xml"? "xml" : "")
if (ext) p.defaultExtension = ext
var ds = this.pathText.value || (ext? elem.getAttribute(ext + "path") : "")
if (ds) {
var d = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile)
try {
d.initWithPath(ds)
var dir = false; try {dir = d.isDirectory()} catch (ex) {}
if (!dir) p.defaultString = d.leafName} catch (ex) {dump("ERROR path: " + ds + "\n")}}
var dp = this.pathText.value || (ext? elem.getAttribute(ext + "path") : "") || elem.getAttribute("dirpath")
if (dp) {
var d = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile)
try {
d.initWithPath(dp)
var dir = null; try {dir = d.isDirectory()} catch (ex) {}
if (dir != null) p.displayDirectory = dir? d : d.parent} catch (ex) {}}
p.init(self, document.title, p.modeSave)
if (p.show() != p.returnCancel) {
this.pathText.value = p.file.path
if (ext) {
elem.setAttribute(ext + "path", p.file.path)
elem.setAttribute("dirpath", p.file.parent.path)
document.persist(elem.id, ext + "path")
document.persist(elem.id, "dirpath")}}
break
default:
dump("logic leak: " + event.type + " from " + elem.localName + " " + elem.id + "\n")
return}
setTimeout(function () {CalfoWizard.compute()}, 0)},page: function (load) {
const tt = ["label", "radio", "checkbox", "button"]
var p = this.wizard.currentPage
for each (var t in tt) {
var ee = p.getElementsByTagName(t)
for (var i = 0; i < ee.length; ++i) {
var e = ee[i], l = null, k = e.getAttribute("accky"), v = ""
if (k) {
switch (t) {
case "label":
l = e
v = e.value
break
case "radio":
case "checkbox":
l = document.getAnonymousElementByAttribute(e, "class", t + "-label")
v = e.getAttribute("label")
break
case "button":
l = null
v = e.getAttribute("label")
break}
if (load) {
e.setAttribute("accesskey", k)
if (l) l.setAttribute("accesskey", k), l.value = v}
else {
e.removeAttribute("accesskey")
if (l) l.removeAttribute("accesskey")}}}}
return true},preview: {
frame: null,doc: null,head: null,body: null,label: {},showLabel: true,showBlank: true,init: function () {
this.frame = document.getElementById("preview-frame")
this.doc = this.frame.contentDocument
this.body = this.doc.body
this.head = this.body.previousSibling
var t = this.head.getElementsByTagName("title")[0]
|| this.head.appendChild(this.doc.createElement("title"))
t.appendChild(this.doc.createTextNode(CalfoWizard.titleText.value))
with (this.head.appendChild(this.doc.createElement("meta"))) {
setAttribute("http-equiv", "content-type")
setAttribute("content", "text/html; charset=utf-8")}
with (this.head.appendChild(this.doc.createElement("meta"))) {
setAttribute("name", "generator")
setAttribute("content", CalfoWizard.appInfo)}
var prof = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile)
var f = prof.clone()
f.append("extensions")
f.append(opener.CalFolder.uuid)
f.append("res")
f.append("reportContent.css")
if (f.exists()) {
with (this.head.appendChild(this.doc.createElement("link"))) {
setAttribute("rel", "stylesheet")
setAttribute("type", "text/css")
setAttribute(
"href",Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(f).spec)}}
var f = prof.clone()
f.append("chrome")
f.append("reportContent.css")
if (f.exists()) {
with (this.head.appendChild(this.doc.createElement("link"))) {
setAttribute("rel", "stylesheet")
setAttribute("type", "text/css")
setAttribute(
"href",Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(f).spec)}}
var i = CalfoWizard.detailList.firstChild
while (i) this.label[i.value] = i.label, i = i.nextSibling},clear: function (spec) {
with (this.body) while (firstChild) removeChild(firstChild)
this.showLabel = spec.showLabel
this.showBlank = spec.showBlank},_para: "",_key: true,head0: function (t, p) {
with (this.body.appendChild(this.doc.createElement("h1"))) {
setAttribute("property", p)
setAttribute("label", this.label[p])
appendChild(this.doc.createTextNode(t))}
this._para = "p1"
this._key = true},head1: function (t, p) {
with (this.body.appendChild(this.doc.createElement("h2"))) {
setAttribute("property", p)
setAttribute("label", this.label[p])
appendChild(this.doc.createTextNode(t))}
this._para = "p2"
this._key = true},para: function (t, p) {
with (this.body.appendChild(this.doc.createElement("p"))) {
className = this._para
+ (this.showLabel? " label" : "")
+ ((this.showBlank || /\S/.test(t))? "" : " empty")
setAttribute("property", p)
setAttribute("label", this.label[p])
if (this._key) setAttribute("key", "true")
appendChild(this.doc.createTextNode(t))}
this._key = false},print: function () {
var ps = Components.classes["@mozilla.org/gfx/printsettings-service;1"].getService(Components.interfaces.nsIPrintSettingsService).newPrintSettings
with (ps) {
headerStrLeft = ""
headerStrCenter = ""
headerStrRight = ""
footerStrLeft = ""
footerStrCenter = ""
footerStrRight = ""
paperSizeUnit = 1
paperWidth = 210
paperHeight = 148
marginTop = 0
marginRight = 0
marginBottom = 0
marginLeft = 0
printInColor = true
printBGColors = true
printSilent = false
showPrintProgress = false
title = CalfoWizard.titleText.value}
var bp = this.frame.contentWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebBrowserPrint)
bp.print(ps, null)},save: function (type, path) {
if (path) {
var f = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile)
f.initWithPath(path)
if (f.exists()) f.remove(false)}
else {
var f = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile)
f.append("folderReport.html")
opener.CalFolder.file_cleanup.push(f)}
try {f.createUnique(f.NORMAL_FILE_TYPE, 0600)}
catch (ex) {
dump("ERROR: preview.save can't create file \n")
return null}
var s = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream)
s.init(f, 0x2A, 0600, 0)
switch (type) {
case "html":
var h = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer).serializeToString(this.doc.documentElement).replace(/></g, ">\n<")
break
case "text":
var h = "", e = this.body.firstChild
while (e) {
switch (e.localName) {
case "H1":
if (h != "") h += "\n"
if (e.className.indexOf("label") >= 0) h+= e.getAttribute("label") + ": "
h += e.firstChild.nodeValue
break
case "H2":
h += "\t"
if (e.className.indexOf("label") >= 0) h+= e.getAttribute("label") + ": "
h += e.firstChild.nodeValue
break
case "P":
if (e.className.indexOf("p1") >= 0) h+= "\t"
else if (e.className.indexOf("p2") >= 0) h+= "\t\t"
if (e.className.indexOf("label") >= 0) h+= e.getAttribute("label") + ": "
h += e.firstChild.nodeValue
break
case "DIV":
h += "\n"
break}
h += "\n"
e = e.nextSibling}
break
case "xml":
var h = '<?xml version="1.0" encoding="UTF-8"?>\n'
+ '<!-- Generator: ' + CalfoWizard.appInfo + ' -->\n'
+ '<!DOCTYPE report SYSTEM "http://calendarhelp.mozdev.org/report.dtd">\n'
+ '<report>\n'
+ '<title>' + CalfoWizard.titleText.value + '</title>\n'
var e = this.body.firstChild, level = 0, caption = false
while (e) {
var l = e.getAttribute("label").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/&/g, "&amp;").replace(/'/g, "&apos;").replace(/"/g, "&quot;")
var v = e.firstChild.nodeValue.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/&/g, "&amp;").replace(/'/g, "&apos;").replace(/"/g, "&quot;")
switch (e.localName) {
case "H1":
if (level == 2) h += '\t</subheading>\n'
if (level >= 1) h += '</heading>\n'
level = 1
h += '<heading>\n'
caption = true
break
case "H2":
if (level == 2) h += '\t</subheading>\n'
level = 2
h += '\t<subheading>\n'
caption = true
break
case "P":
h += '\t\t<detail'
+ ' property="' + e.getAttribute("property") + '"'
+ (e.getAttribute("key") == "true" ? ' key="true"' : "") + '>\n'
+ '\t\t\t<label>' + l + '</label>\n'
+ '\t\t\t<value' + (/\S/.test(v)? '>' + v + '</value>' : '/>') + '\n'
+ '\t\t</detail>\n'
caption = false
break
case "DIV":

break}
if (caption) h += (level == 2? "\t\t" : "\t") + '<caption>' + e.firstChild.nodeValue + '</caption>\n'
e = e.nextSibling}
if (level == 2) h += '\t</subheading>\n'
if (level >= 1) h += '</heading>\n'
h += '</report>'
break}
var UC = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
UC.charset = "utf-8"
h = UC.ConvertFromUnicode(h)
s.write(h, h.length)
s.close()
return f},view: function () {
var f = this.save("html", null)
if (f) onunload = function () {opener.CalFolder.prompt.view(f)}},spacer: function () {
this.body.appendChild(this.doc.createElement("div")).className = "spacer"
this._key = true}},_width: 0,_height: 0,resize: function (event) {
if (!this._width)
this._width = outerWidth, this._height = outerHeight
else if (outerWidth != this._width || outerHeight != this._height)
resizeTo(Math.max(outerWidth, this._width), Math.max(outerHeight, this._height))},step: function (d) {
if (d == 0) this.finish()
setTimeout(function () {CalfoWizard.compute()}, 0)
return d != 0},validate: function (id, val) {
switch (id) {
default:
return val}}}
CalfoAction = {
init: function () {
this._entry.prototype = this._entry_prototype
this.load.init()},load: {
count: NaN,init: function () {
setCursor("wait")
setTimeout(function () {CalfoAction.load.work()}, 50)},display: function (cat, loc) {
var n = CalfoWizard.folder.entries
document.getElementById("intro-entries").value = n
var t = document.getElementById("intro-tell")
if (n == 0) t.value = t.getAttribute("tellno")
else if (n == 1) t.value = t.getAttribute("tellone")
else t.value = t.getAttribute("tellok").replace("%", n)
CalfoWizard.inhibit((n == 0 ? " " : null), t)},work: function () {
var lis = CalfoWizard.seq.GetElements()
CalfoWizard.folder.prepare(null)
CalfoAction._counter.init()
var has = false
while (lis.hasMoreElements()) {
var res = lis.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
CalfoWizard.data.cal(res).getItems(0xffff, 0, null, null, CalfoAction._counter)
var has = true}
if (!has) CalfoAction._counter.onOperationComplete()},finish: function () {
setCursor("default")}},_spec: {
key0: null,key1: null,key2: null,detail: [],showLabel: true,showBlank: true,showTime: true,showZone: true},_data: null,_entry: function (item) {this.item = item},_entry_prototype: {
_showTime: true,_showZone: true,get alarm () {return this.item.alarmTime},get attachments () {return this.item.attachments},get attendees () {return this.item.attendees},get calendar () {return this.item.calendar.name},get category () {return this.item.getProperty("CATEGORIES")},get class () {return this.item.getProperty("CLASS")},get completed () {return this.item.getProperty("COMPLETED")},get created () {return this.item.creationDate},get description () {return this.item.getProperty("DESCRIPTION")},get due () {
var d = this.item.dueDate
if (d) d = d.jsDate
else return ""
if (this._showZone) return d
return d.toLocaleDateString() + (this._showTime? " " + d.toLocaleTimeString() : "")},get end () {
if (this._showZone) return this.item.getProperty("DTEND")
var d = this.item.endDate.jsDate
return d.toLocaleDateString() + (this._showTime? " " + d.toLocaleTimeString() : "")},get generation () {return this.item.generation},get id () {return this.item.id},get location () {return this.item.getProperty("LOCATION")},get modified () {return this.item.getProperty("LAST-MODIFIED")},get organizer () {return this.item.organizer},get priority () {return this.item.priority},get progress () {return 100},get recurrence () {return {id: this.item.recurrenceId, info: this.item.recurrenceInfo}},get stamp () {return this.item.getProperty("DTSTAMP")},get start () {
if (this._showZone) return this.item.getProperty("DTSTART")
var d = this.item.startDate
if (!d) return ""
d = d.jsDate
return d.toLocaleDateString() + (this._showTime? " " + d.toLocaleTimeString() : "")},get status () {return this.item.status},get title () {return this.item.title},get url () {return this.item.getProperty("URL")}},refresh: function (spec) {
var ok = (spec.key0 == this._spec.key0
&& spec.key1 == this._spec.key1
&& spec.key2 == this._spec.key2
&& spec.detail.length == this._spec.detail.length)
&& spec.showLabel == this._spec.showLabel
&& spec.showBlank == this._spec.showBlank
&& spec.showTime == this._spec.showTime
&& spec.showZone == this._spec.showZone
if (ok) for (var i = 0; i < spec.detail.length; ++i)
ok = ok && spec.detail[i] == this._spec.detail[i]
if (ok) return
this._spec = spec
this._data = []
CalfoWizard.preview.clear(spec)
setCursor("wait")
setTimeout(function () {CalfoAction._refresh2()}, 0)},_refresh2: function () {
CalfoWizard.folder.getItems(0xffff, 0, null, null, this)},entries: function (cal, status, type, detail, count, data) {
for each (var i in data) this._data.push(new this._entry(i))},folderComplete: function () {
dump("CalfoAction.folderComplete \n")
var s = this._spec
this._entry.prototype._showTime = true
this._entry.prototype._showZone = true
this._data.sort(function (i, j) {
var k = s.key0
if (k) {
var a = i[k], b = j[k]
if (a > b) return 1
if (a < b) return -1}
k = s.key1
if (k) {
a = i[k], b = j[k]
if (a > b) return 1
if (a < b) return -1}
k = s.key2
if (k) {
a = i[k], b = j[k]
if (a > b) return 1
if (a < b) return -1}
return 0})
this._entry.prototype._showTime = s.showTime
this._entry.prototype._showZone = s.showZone
var pv = CalfoWizard.preview
var w0 = null, w1 = null
for each (var i in this._data) {
var delim = true
if (s.key0) {
var h0 = i[s.key0]
if (h0 != w0) pv.head0(h0, s.key0), w0 = h0, w1 = null, delim = false}
if (s.key1) {
var h1 = i[s.key1]
if (h1 != w1) pv.head1(h1, s.key1), w1 = h1, delim = false}
if (delim) pv.spacer()
pv.para(i[s.key2], s.key2)
for each (var k in s.detail) pv.para(i[k], k)}
setCursor("default")},_counter: {
init: function () {},onOperationComplete: function () {
CalfoAction.load.display(this.cat, this.loc)
CalfoAction.load.finish()},onGetResult: function (cal, status, type, detail, count, data) {
CalfoWizard.folder.onGetResult(cal, status, type, detail, count, data)}}}
getBrowser = function () {
dump("getBrowser \n")
return null}
